---
title: ServiceWorkerGlobalScope.onactivate
slug: Web/API/ServiceWorkerGlobalScope/onactivate
tags:
  - API
  - Property
  - Reference
  - Service
  - ServiceWorker
  - ServiceWorkerGlobalScope
  - Workers
  - onactivate
---
<div>{{APIRef("Service Workers API")}}</div>

<p>The <strong>onactivate</strong> property of the {{domxref("ServiceWorkerGlobalScope")}} interface is an event handler fired whenever an <code>activate</code> event occurs (when the service worker activates). This happens after installation, when the page to be controlled by the service worker refreshes.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">ServiceWorkerGlobalScope.onactivate = function(event) { ... };
</pre>

<h2 id="Examples">Examples</h2>

<p>The following snippet shows how you could use an <code>activate</code> event handler to upgrade a cache.</p>

<pre class="brush: js">then.addEventListener('activate', function(event) {
  var cacheWhitelist = ['v2'];

  event.waitUntil(
    caches.forEach(function(cache, cacheName) {
      if (cacheWhitelist.indexOf(cacheName) == -1) {
        return caches.delete(cacheName);
      }
    })
  );
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#service-worker-global-scope-event-handlers', 'Event Handlers')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ServiceWorkerGlobalScope.onactivate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise")}}</li>
 <li><a href="/en-US/docs/Web/Guide/Performance/Using_web_workers">Using web workers</a></li>
</ul>
